/* KEYBOARD.CPP - Programmed by Maarten Hofman */
/* 220404: Started programming */
/* 290404: Moved some terminal stuff */
/* 230205: Got the old keyboard back */

#include <termio.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <linux/vt.h>
#include <linux/kd.h>
#include "window.h"

#define INPUT_WINDOW_SIZE 20
extern int mscr_tty_fd,mscr_console_fd;

char keybuf[255];
int kbc,keyfd;
struct termios Otty,Ntty;

int getch(void) {
char ch;
int error;

  tcsetattr(keyfd,TCSANOW,&Ntty);
  error=read(keyfd,&ch,1);
  tcsetattr(keyfd,TCSANOW,&Otty);
  return (error==1?(int)ch:-1);
}

bool handle_keyboard(window *show) {
int ret;

  ret=getch();
  if(ret>0) {
    /* We got a character from the keyboard */
    if(ret==8) {
      /* Backspace */
      if(kbc>0) {
        kbc--;
        keybuf[kbc]=0;
      }
      show->clear();
      if(!kbc) return false;
      if(kbc<INPUT_WINDOW_SIZE) {
        show->add_line(keybuf);
      }
      else {
        show->add_line(&keybuf[kbc-INPUT_WINDOW_SIZE]);
      }
      return false;
    }
    keybuf[kbc++]=ret;
    keybuf[kbc]=0;
    if((keybuf[kbc-1]==10)||(keybuf[kbc-1]==13)) {
      keybuf[kbc-1]=10;
      kbc=0;
      return true;
    }
    if(kbc>254) {
      kbc=0;
      return true;
    }
  }
  show->clear();
  if(!kbc) return false;
  if(kbc<INPUT_WINDOW_SIZE) {
    show->add_line(keybuf);
  }
  else {
    show->add_line(&keybuf[kbc-INPUT_WINDOW_SIZE]);
  }
  return false;
}

void open_keyboard_device() {
  keyfd=mscr_tty_fd;
  tcgetattr(keyfd,&Otty);
  Ntty=Otty;
  Ntty.c_iflag=0;
  Ntty.c_oflag=0;
  Ntty.c_lflag&=~ICANON;
  Ntty.c_lflag&=~ECHO;
  Ntty.c_cc[VMIN]=0;
  Ntty.c_cc[VTIME]=0;
  kbc=0;
  keybuf[0]=0;
}

void close_keyboard_device() {
  fprintf(stderr,"Keyboard device closed...\n");
}
